from matplotlib import pyplot as plt
from matplotlib import rc
import numpy as np
import copy

rc('font', **{'family': 'serif', 'serif': ['Computer Modern']})
rc('text', usetex=True)

path = "C:/Users/andrl/Desktop/Experiment 3/"
Fitnessfile = path+"FitnessData.txt"
Degreefile = path+"DegreeData.txt"
Dialoguefile = path+"DialogueData.txt"
Wordfile = path+"UniqueWordsData.txt"
LearnrateFile =  "C:/Users/andrl/Desktop/masterStuff/MasterData/Figures/Experiment 8/LearnRate.txt"
MaxFitnessFile = path+"MaxFitness.txt"
avgVocLenFile = path+"avgVocLen.txt"
SpeakParentsGeneFile = "C:/Users/andrl/Desktop/masterStuff/MasterData/Figures/Experiment 8/SpeakToParents.txt"
ExtrovertFile = "C:/Users/andrl/Desktop/masterStuff/MasterData/Figures/Experiment 8/Extrovert.txt"
Fitness = open(Fitnessfile, 'r')
Degree = open(Degreefile, 'r')
Dialogue = open(Dialoguefile, 'r')
Words = open(Wordfile, 'r')
LearnRate = open(LearnrateFile, 'r')
MaxFitness = open(MaxFitnessFile, 'r')
avgVocLen = open(avgVocLenFile, 'r')
Extrovert = open(ExtrovertFile, 'r')
SpeakParentsGene= open(SpeakParentsGeneFile, 'r')
FitnessData = []
DegreeData = []
DialogueData = []
WordsData = []
LearnRateData = []
MaxFitnessData = []
avgVocLenData = []
ExtrovertData = []
SpeakParentsGeneData = []
for line in Extrovert:
    ExtrovertData.append(float(line))
for line in Fitness:
    FitnessData.append(float(line))
for line in Degree:
    DegreeData.append(float(line))
for line in Dialogue:
    DialogueData.append(float(line))
for line in Words:
    WordsData.append(int(line))
for line in LearnRate:
    LearnRateData.append(float(line))
for line in MaxFitness:
    MaxFitnessData.append(float(line))
for line in avgVocLen:
    avgVocLenData.append(float(line))
for line in SpeakParentsGene:
    SpeakParentsGeneData.append(float(line))
# --- Function: Plot the distribution of speeds in a histogram.
# input : list of speeds, filename of savefile.
# output: none, but saves a figure of the histogram.
def plot_fitness(name, d1, d2):
    plt.xlabel(r'Generations', fontsize=30)#r'$f(v)$', fontsize=30)
    plt.ylabel(r'Fitness', fontsize=30)#r'Speed $v$ [m/s]', fontsize=30)
    plt.xticks(np.arange(0,len(d1),10))
    #plt.yticks(np.arange(0,1, 0.1)    )
    plt.plot(range(len(d1)), d1)#, label=r'Average fitness')
    plt.tick_params(labelsize=20)
    #plt.plot(range(len(d2)), d2, label="Highest fitness")
    #plt.legend(loc=0)

    # --- Saving figure.
    plt.tight_layout()
    if(isSaveFig):
        plt.savefig("C:/Users/andrl/Master-thesis/fig/Results/Exp7.1/Fitness1.png", bbox_inches='tight')
    plt.show()
def plot_words(name, d1):
    plt.ylabel(r'Unique words', fontsize=30)#r'Speed $v$ [m/s]', fontsize=30)
    plt.xlabel(r'Generations', fontsize=30)#r'$f(v)$', fontsize=30)
    plt.xticks(np.arange(0,len(d1),10))
    #plt.yticks(np.arange(0,1,0.1)    )
    plt.plot(range(len(d1)), d1)#, label= r'Nummber of unique highest ranked words')
    plt.tick_params(labelsize=20)
    #plt.legend(loc=0)

    # --- Saving figure.
    plt.tight_layout()
    if(isSaveFig):
        plt.savefig("C:/Users/andrl/Master-thesis/fig/Results/Exp7.1/UniqueWords1.png", bbox_inches='tight')
    plt.show()
def plot_vocabulary(d1):
    plt.ylabel(r"Average vocabulary size", fontsize=30)#r'Speed $v$ [m/s]', fontsize=30)
    plt.xlabel(r'Generations', fontsize=30)#r'$f(v)$', fontsize=30)
    plt.xticks(np.arange(0,len(d1),10))
    #plt.yticks(np.arange(0,1,0.1)    )
    #plt.plot(range(100), d1, label="Nummber of unique highest ranked words")
    plt.plot(range(len(d1)), d1)#, label=r'Successful dialogues / All dialogues')
    #plt.plot(range(len(d2)), d2)#, label=r'Average vocabulary length')
    plt.tick_params(labelsize=20)
    #plt.legend(loc=0)

    # --- Saving figure.
    plt.tight_layout()
    if(isSaveFig):
        plt.savefig("C:/Users/andrl/Master-thesis/fig/Results/Exp7.1/Vocabulary1.png", bbox_inches='tight')
    plt.show()
def plot_succDia(d1):
    plt.ylabel(r"Successful dialogues", fontsize=30)#r'Speed $v$ [m/s]', fontsize=30)
    plt.xlabel(r'Generations', fontsize=30)#r'$f(v)$', fontsize=30)
    plt.xticks(np.arange(0,len(d1),10))
    #plt.yticks(np.arange(0,1,0.1)    )
    #plt.plot(range(100), d1, label="Nummber of unique highest ranked words")
    plt.plot(range(len(d1)), d1)#, label=r'Successful dialogues / All dialogues')
    #plt.plot(range(len(d2)), d2)#, label=r'Average vocabulary length')
    plt.tick_params(labelsize=20)
    #plt.legend(loc=0)

    # --- Saving figure.
    plt.tight_layout()
    if(isSaveFig):
        plt.savefig("C:/Users/andrl/Master-thesis/fig/Results/Exp7.1/SuccDialogues1.png", bbox_inches='tight')
    plt.show()
def plot_genes(name, d1, d2, d3):
    #plt.ylabel("Genes")#r'Speed $v$ [m/s]', fontsize=30)
    plt.xlabel(r'Generations', fontsize=30)#r'$f(v)$', fontsize=30)
    plt.xticks(np.arange(0,len(d1),10))
    #plt.yticks(np.arange(0,1,0.1)    )
    #plt.plot(range(100), d1, label="Nummber of unique highest ranked words")
    plt.plot(range(len(d1)), d1)#, label=r'Learning rate')
    plt.plot(range(len(d2)), d2)#, label=r'Probability of speaking to parents')
    plt.plot(range(len(d3)), d3)#, label=r'Average extrovert probability')
    plt.tick_params(labelsize=20)
    #plt.legend(loc=0)

    # --- Saving figure.
    plt.tight_layout()
    if(isSaveFig):
        plt.savefig("C:/Users/andrl/Master-thesis/fig/Results/Exp4/Genes1.png", bbox_inches='tight')
    plt.show()
def plot_degree(name, d1):
    plt.ylabel(r'Average degree', fontsize=30)#r'Speed $v$ [m/s]', fontsize=30
    plt.xlabel(r'Generations', fontsize=30)#r'$f(v)$', fontsize=30)
    plt.xticks(np.arange(0,len(d1),10))
    #plt.yticks(np.arange(0,1,0.1)    )
    #plt.plot(range(100), d1, label="Nummber of unique highest ranked words")
    plt.plot(range(len(d1)), d1)#, label=r'Average degree')
    plt.tick_params(labelsize=20)
    #plt.legend(loc=0)

    # --- Saving figure.
    plt.tight_layout()
    if(isSaveFig):
        plt.savefig("C:/Users/andrl/Master-thesis/fig/Results/Exp3/Deg1.png", bbox_inches='tight')
    plt.show()
#
#
#path = ""
isSaveFig = True
#plot_fitness("Fitness", FitnessData, MaxFitnessData)
#plot_words("Words", WordsData)
#plot_vocabulary(avgVocLenData)
#plot_succDia(DialogueData)
plot_degree("Degree", DegreeData)
#plot_genes("Genes", LearnRateData, SpeakParentsGeneData, ExtrovertData)
#
