from matplotlib import pyplot as plt
from matplotlib import rc
import numpy as np
import copy

rc('font', **{'family': 'serif', 'serif': ['Computer Modern']})
rc('text', usetex=True)

isSaveFig = True
def exp7abGraph():
    filename = "/UniqueWordsData.txt"
    path = "C:/Users/andrl/Desktop/"
    exp7a = makeData(path+"Experiment 7"+filename)
    exp7b = makeData(path+"Experiment 7.2"+filename)
    plot_exp7abGraph(exp7a, exp7b)
def exp6abGraph():
    filename = "/UniqueWordsData.txt"
    path = "C:/Users/andrl/Desktop/"
    exp6a = makeData(path+"Experiment 6.0"+filename)
    exp6b = makeData(path+"Experiment 6.2"+filename)
    plot_exp6abGraph(exp6a, exp6b)
def succdiaGraph():
    filename = "/DialogueData.txt"
    path = "C:/Users/andrl/Desktop/"
    exp1 = makeData(path+"Experiment 1"+filename)
    exp7 = makeData(path+"Experiment 7"+filename)
    plot_succdia(exp1, exp7)
def hrwGraph():
    filename = "/UniqueWordsData.txt"
    path = "C:/Users/andrl/Desktop/"
    exp1 = makeData(path+"Experiment 1"+filename)
    exp2 = makeData(path+"Experiment 2"+filename)
    exp3 = makeData(path+"Experiment 3"+filename)
    exp4 = makeData(path+"Experiment 4"+filename)
    exp5 = makeData(path+"Experiment 5"+filename)
    exp61 = makeData(path+"Experiment 6.0"+filename)
    exp62 = makeData(path+"Experiment 6.2"+filename)
    exp7 = makeData(path+"Experiment 7"+filename)
    exp72 = makeData(path+"Experiment 7.2"+filename)
    plot_hrw(exp1, exp2, exp3, exp4, exp5, exp61, exp62, exp7, exp72)
def vocabularyGraph():
    filename = "/avgVocLen.txt"
    path = "C:/Users/andrl/Desktop/"
    exp1 = makeData(path+"Experiment 1"+filename)
    exp2 = makeData(path+"Experiment 2"+filename)
    exp3 = makeData(path+"Experiment 3"+filename)
    exp5 = makeData(path+"Experiment 5"+filename)
    exp7 = makeData(path+"Experiment 7"+filename)
    plot_vocabulary(exp1, exp2, exp3, exp5, exp7)
def degreeGraph():
    filename = "/DegreeData.txt"
    path = "C:/Users/andrl/Desktop/"
    exp1 = makeData(path+"Experiment 1"+filename)
    exp2 = makeData(path+"Experiment 2"+filename)
    exp3 = makeData(path+"Experiment 3"+filename)
    exp4 = makeData(path+"Experiment 4"+filename)
    exp5 = makeData(path+"Experiment 5"+filename)
    exp61 = makeData(path+"Experiment 6.0"+filename)
    exp62 = makeData(path+"Experiment 6.2"+filename)
    exp7 = makeData(path+"Experiment 7"+filename)
    plot_degree(exp1, exp2, exp3, exp4, exp5, exp61, exp62, exp7)
def fitnessGraph():
    filename = "/FitnessData.txt"
    path = "C:/Users/andrl/Desktop/"
    exp1 = makeData(path+"Experiment 1"+filename)
    exp2 = makeData(path+"Experiment 2"+filename)
    exp3 = makeData(path+"Experiment 3"+filename)
    exp4 = makeData(path+"Experiment 4"+filename)
    exp5 = makeData(path+"Experiment 5"+filename)
    exp61 = makeData(path+"Experiment 6.0"+filename)
    exp62 = makeData(path+"Experiment 6.2"+filename)
    exp7 = makeData(path+"Experiment 7"+filename)
    plot_fitness(exp1, exp2, exp3, exp4, exp5, exp61, exp62, exp7)

def makeData(fil):
    File = open(fil)
    Data = []
    for line in File:
        Data.append(float(line))
    return Data

def plot_fitness(d1, d2, d3, d4, d5, d6, d7, d8):
    plt.xlabel(r'Generations', fontsize=30)#r'$f(v)$', fontsize=30)
    plt.ylabel(r'Fitness', fontsize=30)#r'Speed $v$ [m/s]', fontsize=30)
    plt.xticks(np.arange(0,max(len(d1), len(d2), len(d3), len(d4), len(d5), len(d6), len(d7), len(d8)),20))
    plt.plot(range(len(d1)), d1, label=r'Experiment 1')
    plt.plot(range(len(d2)), d2, label=r'Experiment 2')
    plt.plot(range(len(d3)), d3, label=r'Experiment 3')
    plt.plot(range(len(d4)), d4, label=r'Experiment 4')
    plt.plot(range(len(d5)), d5, label=r'Experiment 5')
    plt.plot(range(len(d6)), d6, label=r'Experiment 6a')
    plt.plot(range(len(d7)), d7, label=r'Experiment 6b')
    plt.plot(range(len(d8)), d8, label=r'Experiment 7a')
    plt.tick_params(labelsize=20)
    plt.legend(loc=0)

    # --- Saving figure.
    #plt.tight_layout()
    if(isSaveFig):
        plt.savefig("C:/Users/andrl/Master-thesis/fig/Discussion/FitnessComparison.png", bbox_inches='tight')
    plt.show()
def plot_degree(d1, d2, d3, d4, d5, d6, d7, d8):
    plt.xlabel(r'Generations', fontsize=30)#r'$f(v)$', fontsize=30)
    plt.ylabel(r'Degree', fontsize=30)#r'Speed $v$ [m/s]', fontsize=30)
    plt.xticks(np.arange(0,max(len(d1), len(d2), len(d3), len(d4), len(d5), len(d6), len(d7), len(d8)),20))
    plt.plot(range(len(d1)), d1, label=r'Experiment 1')
    plt.plot(range(len(d2)), d2, label=r'Experiment 2')
    plt.plot(range(len(d3)), d3, label=r'Experiment 3')
    plt.plot(range(len(d4)), d4, label=r'Experiment 4')
    plt.plot(range(len(d5)), d5, label=r'Experiment 5')
    plt.plot(range(len(d6)), d6, label=r'Experiment 6a')
    plt.plot(range(len(d7)), d7, label=r'Experiment 6.b')
    plt.plot(range(len(d8)), d8, label=r'Experiment 7a')
    plt.tick_params(labelsize=20)
    #plt.legend(loc='center left', bbox_to_anchor=(1, 0.5))
    plt.legend(loc='upper center', bbox_to_anchor=(0.5, 1.05), ncol=4)

    # --- Saving figure.
    plt.tight_layout()
    if(isSaveFig):
        plt.savefig("C:/Users/andrl/Master-thesis/fig/Discussion/DegreeComparison.png", bbox_inches='tight')
    plt.show()
def plot_vocabulary(d1, d2, d3, d5, d8):
    plt.xlabel(r'Generations', fontsize=30)#r'$f(v)$', fontsize=30)
    plt.ylabel(r'Average vocabulary size', fontsize=30)
    plt.xticks(np.arange(0,max(len(d1), len(d2), len(d3), len(d5), len(d8)),10))
    plt.plot(range(len(d1)), d1, label=r'Experiment 1')
    plt.plot(range(len(d2)), d2, label=r'Experiment 2')
    plt.plot(range(len(d3)), d3, label=r'Experiment 3')
    plt.plot(range(len(d5)), d5, label=r'Experiment 5')
    plt.plot(range(len(d8)), d8, label=r'Experiment 7a')
    plt.tick_params(labelsize=20)
    plt.legend(bbox_to_anchor=(1.0, 1.05))

    # --- Saving figure.
    plt.tight_layout()
    if(isSaveFig):
        plt.savefig("C:/Users/andrl/Master-thesis/fig/Discussion/VocabularyComparison.png", bbox_inches='tight')
    plt.show()
def plot_hrw(d1, d2, d3, d4, d5, d6, d7, d8, d9):
    plt.xlabel(r'Generations', fontsize=30)#r'$f(v)$', fontsize=30)
    plt.ylabel(r'Unique highest ranked words', fontsize=30)#r'Speed $v$ [m/s]', fontsize=30)
    plt.xticks(np.arange(0,max(len(d1), len(d2), len(d3), len(d4), len(d5), len(d6), len(d7), len(d8), len(d9)),20))
    plt.plot(range(len(d1)), d1, label=r'Experiment 1')
    plt.plot(range(len(d2)), d2, label=r'Experiment 2')
    plt.plot(range(len(d3)), d3, label=r'Experiment 3')
    plt.plot(range(len(d4)), d4, label=r'Experiment 4')
    plt.plot(range(len(d5)), d5, label=r'Experiment 5')
    plt.plot(range(len(d6)), d6, label=r'Experiment 6')
    plt.plot(range(len(d7)), d7, label=r'Experiment 6.1')
    plt.plot(range(len(d8)), d8, label=r'Experiment 7')
    plt.plot(range(len(d9)), d9, label=r'Experiment 7.1')
    plt.tick_params(labelsize=20)
    plt.legend(loc=0)

    # --- Saving figure.
    plt.tight_layout()
    if(isSaveFig):
        plt.savefig("C:/Users/andrl/Master-thesis/fig/Discussion/hrwComparison.png", bbox_inches='tight')
    plt.show()
def plot_succdia(d1, d8):
    plt.xlabel(r'Generations', fontsize=30)#r'$f(v)$', fontsize=30)
    plt.ylabel(r'Successful dialogues', fontsize=30)#r'Speed $v$ [m/s]', fontsize=30)
    plt.xticks(np.arange(0,max(len(d1), len(d8)),10))
    plt.plot(range(len(d1)), d1, label=r'Experiment 1')
    plt.plot(range(len(d8)), d8, label=r'Experiment 7')
    plt.tick_params(labelsize=20)
    plt.legend(loc=0)

    # --- Saving figure.
    plt.tight_layout()
    if(isSaveFig):
        plt.savefig("C:/Users/andrl/Master-thesis/fig/Discussion/DialogueComparison.png", bbox_inches='tight')
    plt.show()
def plot_exp6abGraph(d1, d2):
    plt.xlabel(r'Generations', fontsize=30)#r'$f(v)$', fontsize=30)
    plt.ylabel(r'Unique words', fontsize=30)#r'Speed $v$ [m/s]', fontsize=30)
    plt.xticks(np.arange(0,max(len(d1), len(d2)),20))
    plt.plot(range(len(d1)), d1, label=r'Experiment 6a')
    plt.plot(range(len(d2)), d2, label=r'Experiment 6b')
    plt.tick_params(labelsize=20)
    plt.legend(loc=0)

    # --- Saving figure.
    plt.tight_layout()
    if(isSaveFig):
        plt.savefig("C:/Users/andrl/Master-thesis/fig/Results/Exp6/UniqueWordsAB.png", bbox_inches='tight')
    plt.show()
def plot_exp7abGraph(d1, d2):
    plt.xlabel(r'Generations', fontsize=30)#r'$f(v)$', fontsize=30)
    plt.ylabel(r'Unique words', fontsize=30)#r'Speed $v$ [m/s]', fontsize=30)
    plt.xticks(np.arange(0,max(len(d1), len(d2)),10))
    plt.plot(range(len(d1)), d1, label=r'Experiment 7a')
    plt.plot(range(len(d2)), d2, label=r'Experiment 7b')
    plt.tick_params(labelsize=20)
    plt.legend(loc=0)

    # --- Saving figure.
    plt.tight_layout()
    if(isSaveFig):
        plt.savefig("C:/Users/andrl/Master-thesis/fig/Results/Exp7/UniqueWordsAB.png", bbox_inches='tight')
    plt.show()
#vocabularyGraph()
#fitnessGraph()
#degreeGraph()
#hrwGraph()
#succdiaGraph()
exp6abGraph()
#exp7abGraph()
